package com.ejie.ad74a.util.constantes;

import java.util.Locale;

import org.springframework.context.i18n.LocaleContextHolder;

import com.ejie.ad74a.model.Combo;
import com.ejie.ad74a.util.comun.Utilidades;

/**
 * Estados de un expediente
 */

public enum TipoResol24Enum {

	RESUELTA_CA("1", "tipoResol24.resuelta.ca"), //
	RESUELTA_UM("2", "tipoResol24.resuelta.um"), //
	RESUELTA_SOCIO_FAMILIAR("3", "tipoResol24.resuelta.socio.familiar"), //
	RESUELTA_EMERGENCIAS("4", "tipoResol24.resuelta.emergencias");

	private TipoResol24Enum(String id, String labelDesc) {
		this.labelDesc = labelDesc;
		this.id = id;
	}

	private String id;
	private String labelDesc;

	public String getId() {
		return this.id;
	}

	public String getLabelDesc() {
		return Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
				LocaleContextHolder.getLocale());
	}

	public String getLabelDesc(Locale locale) {
		return Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc, locale);
	}

	public Combo getCombo() {
		return new Combo(id.toString(),
				Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
						com.ejie.ad74a.constantes.Constantes.LOCALE_ES),
				Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
						com.ejie.ad74a.constantes.Constantes.LOCALE_EU));
	}

	public static TipoResol24Enum getById(String id) {
		for (TipoResol24Enum e : values()) {
			if (e.id.equals(id))
				return e;
		}
		return null;
	}

	public static boolean exists(String value) {

		for (TipoResol24Enum tipo : TipoResol24Enum.values()) {
			if (tipo.getId().equals(value)) {
				return true;
			}
		}

		return false;
	}

}
